/*
 *  Copyright (c) 2009 Luca Abeni
 *
 *  This is free software; see gpl-3.0.txt
 */

#include <stdio.h>

#include "stream.h"

struct dups *dups_read(const char *fname)
{
  static struct dups d[1000];
  FILE *f;
  int i;

  f = fopen(fname, "r");
  if (f == NULL) {
    return NULL;
  }

  i = 0;
  while (!feof(f)) {
    int res;

    res = fscanf(f, "Duplicate %d %d times\n", &d[i].frame, &d[i].amount);
    if (res == 2) {
      i++;
    }
  }
  d[i].frame = -1;
  
  i = 0;
  while(d[i].frame != -1) {
    printf("Dup[%d]: %d, %d\n", i, d[i].frame, d[i].amount);
    i++;
  }

  return d;
}

int main(int argc, char *argv[])
{
  void *s;
  int done;
  struct dups *d;

  if (argc < 4) {
    fprintf(stderr, "Usage: %s <fname> <out fname> <dups file>\n", argv[0]);

    return -1;
  }

  d = dups_read(argv[3]);

  s = stream_open(argv[1], argv[2], d);
  if (s == NULL) {
    fprintf(stderr, "Error opening %s\n", argv[1]);

    return -1;
  }

  done = 0;
  while(!done) {
    void *pkt_handle;

    pkt_handle = stream_read(s);
    if (pkt_handle == NULL) {
        done = 1;
    } else {
      stream_process(s, pkt_handle);
    }
  }

  stream_close(s);

  return 0;
}
